<script setup lang="ts">
import type { VbenFormProps } from '@vben/common-ui';

import type { VxeGridProps } from '#/adapter/vxe-table';

import { onMounted, ref } from 'vue';

import { Page, useVbenDrawer } from '@vben/common-ui';

import { ElMessageBox } from 'element-plus';

import { useVbenVxeGrid } from '#/adapter/vxe-table';

import { certificateSettingList, deleteCertificateSetting, exportCertificateSetting } from '#/api/system/infoEntry/certificateSetting/certificateSetting';
import { commonDownloadExcel } from '#/utils/file/download';

import { queryFormSchema, tableColumns } from './certificateSetting-data';
import CertificateSettingDrawerComp from './certificateSetting-drawer.vue';

const formOptions: VbenFormProps = {
  commonConfig: {
    labelWidth: 80,
    componentProps: {
      allowClear: true,
    },
  },
  schema: queryFormSchema(),
  wrapperClass: 'grid-cols-1 md:grid-cols-2 lg:grid-cols-4',
};

const gridOptions: VxeGridProps = {
  checkboxConfig: {
    highlight: true,
    reserve: true,
    trigger: 'default',
  },
  columns: tableColumns,
  size: 'medium',
  height: 'auto',
  proxyConfig: {
    ajax: {
      query: async ({ page }, formValues = {}) => {
        const resp = await certificateSettingList({
          ...formValues,
          pageNum: page.currentPage,
          pageSize: page.pageSize,
        });
        return { items: resp.rows, total: resp.total };
      },
    },
  },
  rowConfig: {
    keyField: 'id',
  },
  toolbarConfig: {
    custom: true,
    refresh: true,
    zoom: true,
  },
  id: 'system-infoEntry-certificateSetting-index',
};

const [BasicTable, basicTableApi] = useVbenVxeGrid({
  formOptions,
  gridOptions,
});

const [CertificateSettingDrawer, drawerApi] = useVbenDrawer({
  connectedComponent: CertificateSettingDrawerComp,
});

// 新增证照规则
function openDrawer() {
  drawerApi.setData({ isUpdate: false }).open();
}

// 编辑证照规则
function handleEdit(row: any) {
  console.log(row);
  // row.taskSource = row.taskSource
  drawerApi.setData({ ...row, isUpdate: true }).open();
}

// 单个删除证照规则
async function confirmEvent(row: any) {
  await deleteCertificateSetting([row.id]);
  await basicTableApi.reload();
}

// 批量删除证照规则
function deleteHandle() {
  const checkRecords = basicTableApi.grid.getCheckboxRecords();
  const ids = checkRecords.map((item: any) => item.id);
  if (ids.length <= 0) {
    return;
  }

  ElMessageBox.confirm(`确认删除选中的${ids.length}条数据吗?`, '提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning',
  }).then(async () => {
    await deleteCertificateSetting(ids);
    await basicTableApi.reload();
  });
}

// 导出证照规则数据
async function exportHandle() {
  await commonDownloadExcel(
    exportCertificateSetting,
    '证照规则数据',
    basicTableApi.formApi.form.values,
  );
}
</script>

<template>
  <Page :auto-content-height="true">
    <BasicTable table-title="证照规则设置列表">
      <template #toolbar-tools>
        <ElSpace>
          <!-- <ElButton type="warning" @click="exportHandle" >导出</ElButton> -->
          <ElButton
            type="danger"
            :disabled="
              !(basicTableApi?.grid?.getCheckboxRecords?.()?.length > 0)
            "
            @click="deleteHandle"
          >
            批量删除
          </ElButton>
          <ElButton
            type="primary"
            @click="openDrawer"
          >
            新增证照规则
          </ElButton>
        </ElSpace>
      </template>
      <template #action="{ row }">
        <ElSpace>
          <ElButton
            size="small"
            type="primary"
            plain
            @click="handleEdit(row)"
          >
            编辑
          </ElButton>
          <ElPopconfirm title="确认删除" @confirm="confirmEvent(row)">
            <template #reference>
              <ElButton
                size="small"
                type="danger"
                plain
              >
                删除
              </ElButton>
            </template>
          </ElPopconfirm>
        </ElSpace>
      </template>
    </BasicTable>
    <CertificateSettingDrawer @reload="basicTableApi.reload()" />
  </Page>
</template>

<style scoped lang="scss">
:deep(.el-tooltip__trigger:focus) {
  outline: none;
}
</style>
